Package org.kie.api.runtime.manager.audit

## Interface NodeInstanceLog

-     public interface NodeInstanceLog

  Audit view of node instance where each node instance (in most of the cases) will have two entries:
  - when node instance was triggered
  - when node instance was left - completed

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static int` | `TYPE_ABORTED` | Indicates that the node instance was left because an abort operation (it is not active anymore)
    `static int` | `TYPE_ASYNC_ENTER` | Indicates that node instance was triggered
    `static int` | `TYPE_ENTER` | Indicates that node instance was triggered
    `static int` | `TYPE_ERROR` | indicates that the node was left because an error
    `static int` | `TYPE_EXIT` | Indicates that node instance was left (it's no more active)
    `static int` | `TYPE_OBSOLETE` | Indicates that the node was left because of the workflow considered not needed to be executed
    `static int` | `TYPE_SKIPPED` | Indicates that the node was taking another route because a signal, timeout, escanalation.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `String` | `getConnection()` | Incoming or outgoing connection identifier (sequence flow) for given node.
    `Date` | `getDate()` |
    `String` | `getExternalId()` |
    `String` | `getNodeId()` |
    `String` | `getNodeInstanceId()` |
    `String` | `getNodeName()` |
    `String` | `getNodeType()` |
    `String` | `getProcessId()` |
    `Long` | `getProcessInstanceId()` |
    `Integer` | `getType()` |
    `Long` | `getWorkItemId()` |

- - ### Field Detail

    - #### TYPE_ENTER

          static final int TYPE_ENTER

      Indicates that node instance was triggered
      See Also:
        Constant Field Values

    - #### TYPE_EXIT

          static final int TYPE_EXIT

      Indicates that node instance was left (it's no more active)
      See Also:
        Constant Field Values

    - #### TYPE_ABORTED

          static final int TYPE_ABORTED

      Indicates that the node instance was left because an abort operation (it is not active anymore)
      See Also:
        Constant Field Values

    - #### TYPE_SKIPPED

          static final int TYPE_SKIPPED

      Indicates that the node was taking another route because a signal, timeout, escanalation.
      See Also:
        Constant Field Values

    - #### TYPE_OBSOLETE

          static final int TYPE_OBSOLETE

      Indicates that the node was left because of the workflow considered not needed to be executed
      See Also:
        Constant Field Values

    - #### TYPE_ERROR

          static final int TYPE_ERROR

      indicates that the node was left because an error
      See Also:
        Constant Field Values

    - #### TYPE_ASYNC_ENTER

          static final int TYPE_ASYNC_ENTER

      Indicates that node instance was triggered
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### getProcessInstanceId

          Long getProcessInstanceId()

      Returns:
        process instance identifier

    - #### getProcessId

          String getProcessId()

      Returns:
        id of the definition

    - #### getNodeInstanceId

          String getNodeInstanceId()

      Returns:
        identifier of the node instance

    - #### getNodeId

          String getNodeId()

      Returns:
        identifier of the node which usually is the unique identifier from process definition, but can be unique identifier assigned by the engine when unique id is not available

    - #### getNodeName

          String getNodeName()

      Returns:
        name of the node from process definition

    - #### getDate

          Date getDate()

      Returns:
        date on when this node was triggered

    - #### getWorkItemId

          Long getWorkItemId()

      Returns:
        identifier of work item that this node refers to, might be null if it's not work item based node

    - #### getConnection

          String getConnection()

      Incoming or outgoing connection identifier (sequence flow) for given node. Incoming or outgoing depends on the type of the node instance log entry where
      - entry type will contain incoming sequence flow
      - exit type will contain outgoing sequence flow
      Returns:
        Incoming or outgoing connection identifier
      See Also:
        `getType()`

    - #### getExternalId

          String getExternalId()

      Returns:
        external (optional) identifier associated with this process instance

    - #### getNodeType

          String getNodeType()

      Returns:
        Node type that indicates what sort of activity it was e.g. Human Task, Script Task, etc

    - #### getType

          Integer getType()

      Returns:
        Type of the node instance log entry - Entry or Exit
      See Also:
        `TYPE_ENTER`, `TYPE_EXIT`